package com.muyu.compile;


import com.muyu.common.core.domain.Result;
import com.muyu.constant.MethodSuffix;
import com.muyu.upload.ALiYunUpload;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.tools.*;
import java.io.*;
import java.net.MalformedURLException;
import java.net.URL;
import java.nio.file.Path;
import java.nio.file.Paths;

/**
 * @Author：蓬叁
 * @Package：com.muyu.compile
 * @Project：cloud-rule
 * @name：OSSFileCompile
 * @Date：2024/8/31 下午7:08
 */
public class FilesCompilerLoad {

    private static final Logger log = LoggerFactory.getLogger(FilesCompilerLoad.class);

    public static Result<Object> javaCompiler(String fileName){


            JavaCompiler compiler = ToolProvider.getSystemJavaCompiler();
            String[] strings = {"-classpath","/home/lib","-verbose","-d", "/home/lib","home/"+fileName + MethodSuffix.JAVASUFFIX };
            // 执行编译任务
            int result = compiler.run(null, null, null, strings);
            // 检查编译结果
            if (result == 0) {
                System.out.println("编译成功，生成的.class文件位于源代码同目录");
            } else {
                System.out.println("编译失败");
            }

            try {
                String classContent = "";
                BufferedReader bufferedReader = new BufferedReader(new FileReader("/home/lib/com/muyu/generate/"+fileName+ MethodSuffix.CLASSSUFFIX));
                String line;
                while ((line = bufferedReader.readLine()) != null) {
                    System.out.println(line);
                    classContent += line;
                }
                bufferedReader.close();
                log.info("文件存储:" + fileName + MethodSuffix.CLASSSUFFIX);
                ALiYunUpload.uploadClassFiles(classContent,fileName);

            } catch (IOException e) {
                e.printStackTrace();
            }

        return Result.success();
    }

    public static Result<Object> classLoad(String fileName){

        try {
            // class文件路径
            String externalClassFilePath = "/home/lib/com/muyu/generate/"+fileName + MethodSuffix.CLASSSUFFIX;
            log.info(externalClassFilePath);
            Path path = Paths.get(externalClassFilePath);

            String externalClassDir = externalClassFilePath.substring(0, externalClassFilePath.lastIndexOf('/'));

            URL[] urls = new URL[]{new File(externalClassDir).toURI().toURL()};

            ExternalClassLoader externalClassLoader = new ExternalClassLoader(urls);
            log.info("开始创建加载器...");
            // 加载类
            // 注意类名必须是完全限定名（包括包名）
            Class<?> clazz = externalClassLoader.loadClassFromPath(path, "com.muyu.generate."+fileName);
            System.out.println(clazz);

        } catch (MalformedURLException e) {
            throw new RuntimeException(e);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        return Result.success();
    }

}
